#include <iostream>
#include <fstream>
#include <string.h>
#include <stdlib.h>
using namespace std;

const int R = 10;
const int C = 20;
const int MAXL = 50;

struct Libro {
  char titolo[MAXL];
  char autore[MAXL];  
  int pag;
  float pr;
  bool occupato;
};

struct Scaffale {
  Libro libro[R][C];
};


bool salva(const Scaffale* ps, const char nf[], int nr);
int quantiLibri(const Scaffale* ps, const char nome[]);
void piuPagine(const Scaffale* ps, int* pr, int* pc);
int ordPrezzo(const Scaffale* ps, Libro al[], int r);
bool elimina(Scaffale* ps, char parola[], int i);


void stampa(const Scaffale* ps) {
  for(int i=0; i<R; i++){
    cout << "Ripiano " << i << endl;
    for(int j=0; ps->libro[i][j].occupato; j++)
      cout << ps->libro[i][j].titolo << ", " << ps->libro[i][j].autore 
           << ", pr.=" << ps->libro[i][j].pr << ", pag.=" << ps->libro[i][j].pag 
           << endl;
  }
}

void riempi(Scaffale* ps) {
  for(int i=0; i<R; i++)
    for(int j=0; j<C; j++)
      ps->libro[i][j].occupato = false;
  Libro l;
  fstream ff;
  ff.open("input.txt", ios::in);
  if(!ff) {
    cerr << "Non riesco ad aprire il file" << endl;
    exit(1);
  }
  int i=0; 
  int j=0;
  while(ff >> l.titolo) {
    if(strcmp(l.titolo, "---")==0) {
      i++;
      j=0;
      continue;
    }
    ff >> l.autore >> l.pag >> l.pr;
    l.occupato = true;
    ps->libro[i][j] = l;
    j++;
  }
}

void sep(){
  for(int i=0; i<40; i++)
    cout << "-";
  cout << endl;
}

int main(){
  Scaffale scaf;
  riempi(&scaf);  
  sep();
  cout << "Stato iniziale dello scaffale:" << endl;
  stampa(&scaf);
  system("pause");

  sep();
  cout << "Provo a salvare il contenuto del ripiano 0 in rip0.txt" << endl;
  if(!salva(&scaf, "rip0.txt", 0)) cout << "Problemi nel salvataggio" << endl;
  cout << "Contenuto di rip0.txt:" << endl; 
  system("type rip0.txt");
  system("pause");

  sep();
  cout << "Provo a salvare il contenuto del ripiano 1 in rip1.txt" << endl;
  if(!salva(&scaf, "rip1.txt", 1)) cout << "Problemi nel salvataggio" << endl;
  cout << "Contenuto di rip1.txt:" << endl; 
  system("type rip1.txt");
  system("pause");

  sep();
  cout << "Provo la funzione quanti:" << endl;
  int q = quantiLibri(&scaf, "J._Steinbeck");
  cout << "Nello scaffale ci sono " << q << " libri di J._Steinbeck" << endl;
  q = quantiLibri(&scaf, "T._Tasso");
  cout << "Nello scaffale ci sono " << q << " libri di T._Tasso" << endl;
  q = quantiLibri(&scaf, "A._Burgess");
  cout << "Nello scaffale ci sono " << q << " libri di A._Burgess" << endl;
  system("pause");

  sep();
  int riga, colonna;
  piuPagine(&scaf, &riga, &colonna);
  if(riga == -1 && colonna == -1) 
    cout << "Lo scaffale non contiene libri" << endl;
  else
    cout << "Il libro che ha piu' pagine e' " << scaf.libro[riga][colonna].titolo << endl;
  system("pause");

  sep();
  cout << "Provo la funzione ordPrezzo (ripiano 0):" << endl;
  Libro ll[C]; 
  int n = ordPrezzo(&scaf, ll, 0);
  for(int j=0; j<n; j++)
    cout << ll[j].titolo << ", " << ll[j].autore
         << ", pr.=" << ll[j].pr << ", pag.=" << ll[j].pag
         << endl;
  system("pause");
  sep();
  cout << "Provo la funzione ordPrezzo (ripiano 1):" << endl;
  n = ordPrezzo(&scaf, ll, 1);
  for(int j=0; j<n; j++)
    cout << ll[j].titolo << ", " << ll[j].autore
         << ", pr.=" << ll[j].pr << ", pag.=" << ll[j].pag
         << endl;
  system("pause");

  sep();
  cout << "Provo la funzione elimina:" << endl;
  cout << "Tento di eliminare il primo libro del ripiano 0 il cui titolo contiene la parola Castigo" << endl;
  if(elimina(&scaf, "Castigo", 0)) cout << "Eliminato" << endl;
  else cout << "Non eliminato" << endl;
  cout << "Contenuto dello scaffale:" << endl;
  stampa(&scaf);
  system("pause");
  sep();
  cout << "Tento di eliminare il primo libro del ripiano 2 il cui titolo contiene la parola Civetta" << endl;
  if(elimina(&scaf, "Civetta", 2)) cout << "Eliminato" << endl;
  else cout << "Non eliminato" << endl;
  cout << "Contenuto dello scaffale:" << endl;
  stampa(&scaf);
  system("pause");

  return 0;
}
