#include <iostream>
#include <fstream>
#include <string.h>
using namespace std;

const int R = 10;
const int C = 20;
const int MAXL = 50;

struct Libro {
  char titolo[MAXL];
  char autore[MAXL];  
  int pag;
  float pr;
  bool occupato;
};

struct Scaffale {
  Libro libro[R][C];
};


bool salva(const Scaffale* ps, const char nf[], int nr){
  fstream ff;
  ff.open(nf, ios::out); 
  if(!ff || nr<0 || nr>=R)
    return false;
  int i = 0;
  while(ps->libro[nr][i].occupato && i<C) {
    ff << ps->libro[nr][i].autore << ", " << ps->libro[nr][i].titolo << ", " 
       << ps->libro[nr][i].pag << ", " << ps->libro[nr][i].pr << endl; 
    i++;
  }
  return true;
}

int quantiLibri(const Scaffale* ps, const char nome[]){
  int n = 0;
  for(int i=0; i<R; i++) {
    int j=0;
    while(ps->libro[i][j].occupato && j<C) {
      if(strcmp(ps->libro[i][j].autore, nome) == 0) n++;
      j++; 
    }
  }
  return n;
}

void piuPagine(const Scaffale* ps, int* pr, int* pc){
  *pr = -1;
  *pc = -1;
  int maxpag = 0;
  for(int i=0; i<R; i++) {
    int j=0;
    while(ps->libro[i][j].occupato && j<C) {
      if(ps->libro[i][j].pag > maxpag) {
        maxpag = ps->libro[i][j].pag;
        *pr = i;
        *pc = j;
      }
      j++; 
    }
  }
}

void ordina(Libro al[], int n){
  bool ordinato = false;
  for(int i=0; i<n-1 && !ordinato; i++) {
    ordinato = true;
    for(int j=n-1; j>=i+1; j--)
      if(al[j].pr < al[j-1].pr){
        ordinato = false;
        Libro tmp = al[j];
        al[j] = al[j-1];
        al[j-1] = tmp;
      }
  }
}

int ordPrezzo(const Scaffale* ps, Libro al[], int r){
  int j=0;
  while(ps->libro[r][j].occupato && j<C) {
    al[j] = ps->libro[r][j];
    j++;
  }
  ordina(al, j);
  return j; 
}

bool elimina(Scaffale* ps, char parola[], int i) {
  int j;
  for(j=0; ps->libro[i][j].occupato && strstr(ps->libro[i][j].titolo, parola) == NULL && j<C; j++);
  if(j==C || !ps->libro[i][j].occupato) return false;
  for(; ps->libro[i][j].occupato && j<C-1; j++)
    ps->libro[i][j] = ps->libro[i][j+1];
  return true;
}
